aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--circle.yml20
-rw-r--r--readme.rst3
-rwxr-xr-xsrc/scripts/ci/circle/clang-shared-debug.sh10
-rwxr-xr-xsrc/scripts/ci/circle/clang-static-debug.sh10
-rwxr-xr-xsrc/scripts/ci/circle/gcc-shared-debug.sh10
-rwxr-xr-xsrc/scripts/ci/circle/gcc-static-debug.sh10
6 files changed, 63 insertions, 0 deletions
diff --git a/circle.yml b/circle.yml
new file mode 100644
index 000000000..5355df733
--- /dev/null
+++ b/circle.yml
@@ -0,0 +1,20 @@
+dependencies:
+ pre:
+ - sudo add-apt-repository -y 'deb http://llvm.org/apt/precise/ llvm-toolchain-precise-3.6 main'
+ - sudo add-apt-repository -y ppa:ubuntu-toolchain-r/test
+ - wget -q -O - http://llvm.org/apt/llvm-snapshot.gpg.key | sudo apt-key add -
+ - sudo apt-get update -qq
+ override:
+ - sudo apt-get install g++-4.8 clang-3.6
+ post:
+ - sudo update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-4.8 99
+ - sudo update-alternatives --install /usr/bin/clang++ clang++ /usr/bin/clang++-3.6 99
+ - g++ --version
+ - clang++ --version
+
+test:
+ override:
+ - runall() { for f in "$@"; do bash $f; done }; runall:
+ parallel: true
+ files:
+ - src/scripts/ci/circle/*.sh
diff --git a/readme.rst b/readme.rst
index a246d4337..ac1014188 100644
--- a/readme.rst
+++ b/readme.rst
@@ -49,6 +49,9 @@ There is also a third party open source implementation of
.. image:: https://ci.appveyor.com/api/projects/status/n9f94dljd03j2lce?svg=true
:target: https://ci.appveyor.com/project/randombit/botan/branch/master
+.. image:: https://circleci.com/gh/randombit/botan.svg?style=shield
+ :target: https://circleci.com/gh/randombit/botan
+
.. image:: https://botan-ci.kullo.net/badge
:target: https://botan-ci.kullo.net/
diff --git a/src/scripts/ci/circle/clang-shared-debug.sh b/src/scripts/ci/circle/clang-shared-debug.sh
new file mode 100755
index 000000000..2ef4e6dd5
--- /dev/null
+++ b/src/scripts/ci/circle/clang-shared-debug.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+set -ev
+which shellcheck > /dev/null && shellcheck "$0" # Run shellcheck on this if available
+
+BUILD_NICKNAME=$(basename "$0" .sh)
+BUILD_DIR="./build-$BUILD_NICKNAME"
+
+./configure.py --with-build-dir="$BUILD_DIR" --build-mode=debug --cc=clang
+make -j 2 -f "$BUILD_DIR"/Makefile
+"$BUILD_DIR"/botan-test
diff --git a/src/scripts/ci/circle/clang-static-debug.sh b/src/scripts/ci/circle/clang-static-debug.sh
new file mode 100755
index 000000000..8bf96fcfe
--- /dev/null
+++ b/src/scripts/ci/circle/clang-static-debug.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+set -ev
+which shellcheck > /dev/null && shellcheck "$0" # Run shellcheck on this if available
+
+BUILD_NICKNAME=$(basename "$0" .sh)
+BUILD_DIR="./build-$BUILD_NICKNAME"
+
+./configure.py --with-build-dir="$BUILD_DIR" --build-mode=debug --cc=clang --disable-shared --via-amalgamation
+make -j 2 -f "$BUILD_DIR"/Makefile
+"$BUILD_DIR"/botan-test
diff --git a/src/scripts/ci/circle/gcc-shared-debug.sh b/src/scripts/ci/circle/gcc-shared-debug.sh
new file mode 100755
index 000000000..93530b8ac
--- /dev/null
+++ b/src/scripts/ci/circle/gcc-shared-debug.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+set -ev
+which shellcheck > /dev/null && shellcheck "$0" # Run shellcheck on this if available
+
+BUILD_NICKNAME=$(basename "$0" .sh)
+BUILD_DIR="./build-$BUILD_NICKNAME"
+
+./configure.py --with-build-dir="$BUILD_DIR" --build-mode=debug
+make -j 2 -f "$BUILD_DIR"/Makefile
+"$BUILD_DIR"/botan-test
diff --git a/src/scripts/ci/circle/gcc-static-debug.sh b/src/scripts/ci/circle/gcc-static-debug.sh
new file mode 100755
index 000000000..c7d23b9b0
--- /dev/null
+++ b/src/scripts/ci/circle/gcc-static-debug.sh
@@ -0,0 +1,10 @@
+#!/bin/bash
+set -ev
+which shellcheck > /dev/null && shellcheck "$0" # Run shellcheck on this if available
+
+BUILD_NICKNAME=$(basename "$0" .sh)
+BUILD_DIR="./build-$BUILD_NICKNAME"
+
+./configure.py --with-build-dir="$BUILD_DIR" --build-mode=debug --disable-shared --via-amalgamation
+make -j 2 -f "$BUILD_DIR"/Makefile
+"$BUILD_DIR"/botan-test